#include "ast.h"
#include "log.h"

const char *
ast_expression_str(struct ast_expression *expression)
{
#define TRANSLATE(e) case e: return #e;
	switch (expression->type) {
	TRANSLATE(AST_NONE);
	TRANSLATE(AST_ASSIGNMENT);
	TRANSLATE(AST_CONDITION);
	TRANSLATE(AST_OR);
	TRANSLATE(AST_AND);
	TRANSLATE(AST_EQUALITY);
	TRANSLATE(AST_RELATION);
	TRANSLATE(AST_ADDITION);
	TRANSLATE(AST_MULTIPLICATION);
	TRANSLATE(AST_UNARY);
	TRANSLATE(AST_SUBSCRIPT);
	TRANSLATE(AST_FUNCTION);
	TRANSLATE(AST_METHOD);
	TRANSLATE(AST_IDENTIFIER);
	TRANSLATE(AST_STRING);
	TRANSLATE(AST_ARRAY);
	TRANSLATE(AST_BOOL);
	default:
		report("unknown token");
		break;
	}
#undef TRANSLATE
	return "";
}

